/**
 * @hidden
 */
export const thisIsAModule = true;

/**
 *
 */

declare global {
  var _allCaches: any;
}

globalThis._allCaches = new Map();

const cache = {
  set: (params: any) => {
    const { cacheId, key, value } = params;
    if (!_allCaches.has(cacheId)) {
      _allCaches.set(cacheId, new Map());
    }
    const k = _allCaches.get(cacheId);
    k.set(key, value);
  },
  get: (params: any) => {
    const { cacheId, key } = params;
    if (!_allCaches.has(cacheId)) {
      return null;
    }
    const k = _allCaches.get(cacheId);
    if (!k.has(key)) {
      return null;
    }
    const value = k.get(key);
    k.delete(key);
    k.set(key, value);
    return value;
  },
  delete: (params: any) => {
    const { cacheId, key } = params;
    if (!_allCaches.has(cacheId)) {
      return null;
    }
    const k = _allCaches.get(cacheId);
    if (!k.has(key)) {
      return null;
    }
    const value = k.get(key);
    k.delete(key);
    return value;
  },
};

export default cache;
